Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.awt.image
Class RescaleOp

    java.lang.Object
      |
      +--java.awt.image.RescaleOp

All Implemented Interfaces:
  BufferedImageOp, RasterOp

public class RescaleOp
extends Object
implements BufferedImageOp, RasterOp

This class performs a pixel-by-pixel rescaling of the data in the source image by multiplying the sample values for each pixel by a scale factor and then adding an offset. The scaled sample values are clipped to the minimum/maximum representable in the destination image.

The pseudo code for the rescaling operation is as follows:

    for each pixel from Source object {
        for each band/component of the pixel {
            dstElement = (srcElement*scaleFactor) + offset
        }
    }

For Rasters, rescaling operates on bands. The number of sets of scaling constants may be one, in which case the same constants are applied to all bands, or it must equal the number of Source Raster bands.

For BufferedImages, rescaling operates on color and alpha components. The number of sets of scaling constants may be one, in which case the same constants are applied to all color (but not alpha) components. Otherwise, the number of sets of scaling constants may equal the number of Source color components, in which case no rescaling of the alpha component (if present) is performed. If neither of these cases apply, the number of sets of scaling constants must equal the number of Source color components plus alpha components, in which case all color and alpha components are rescaled.

BufferedImage sources with premultiplied alpha data are treated in the same manner as non-premultiplied images for purposes of rescaling. That is, the rescaling is done per band on the raw data of the BufferedImage source without regard to whether the data is premultiplied. If a color conversion is required to the destination ColorModel, the premultiplied state of both source and destination will be taken into account for this step.

Images with an IndexColorModel cannot be rescaled.

If a RenderingHints object is specified in the constructor, the color rendering hint and the dithering hint may be used when color conversion is required.

Note that in-place operation is allowed (i.e. the source and destination can be the same object).

See Also:
  `RenderingHints.KEY_COLOR_RENDERING`, `RenderingHints.KEY_DITHERING`

Constructor Summary
`RescaleOp(float[] scaleFactors, float[] offsets, RenderingHints hints)` Constructs a new RescaleOp with the desired scale factors and offsets.
`RescaleOp(float scaleFactor, float offset, RenderingHints hints)` Constructs a new RescaleOp with the desired scale factor and offset.

Method Summary
`BufferedImage` | `createCompatibleDestImage(BufferedImage src, ColorModel destCM)` Creates a zeroed destination image with the correct size and number of bands.
`WritableRaster` | `createCompatibleDestRaster(Raster src)` Creates a zeroed destination Raster with the correct size and number of bands, given this source.
`BufferedImage` | `filter(BufferedImage src, BufferedImage dst)` Rescales the source BufferedImage.
`WritableRaster` | `filter(Raster src, WritableRaster dst)` Rescales the pixel data in the source Raster.
`Rectangle2D` | `getBounds2D(BufferedImage src)` Returns the bounding box of the rescaled destination image.
`Rectangle2D` | `getBounds2D(Raster src)` Returns the bounding box of the rescaled destination Raster.
`int` | `getNumFactors()` Returns the number of scaling factors and offsets used in this RescaleOp.
`float[]` | `getOffsets(float[] offsets)` Returns the offsets in the given array.
`Point2D` | `getPoint2D(Point2D srcPt, Point2D dstPt)` Returns the location of the destination point given a point in the source.
`RenderingHints` | `getRenderingHints()` Returns the rendering hints for this op.
`float[]` | `getScaleFactors(float[] scaleFactors)` Returns the scale factors in the given array.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### RescaleOp

    public RescaleOp(float[] scaleFactors,
                     float[] offsets,
                     RenderingHints hints)

  Constructs a new RescaleOp with the desired scale factors and offsets. The length of the scaleFactor and offset arrays must meet the restrictions stated in the class comments above. The RenderingHints argument may be null.

### RescaleOp

    public RescaleOp(float scaleFactor,
                     float offset,
                     RenderingHints hints)

  Constructs a new RescaleOp with the desired scale factor and offset. The scaleFactor and offset will be applied to all bands in a source Raster and to all color (but not alpha) components in a BufferedImage. The RenderingHints argument may be null.

Method Detail

### getScaleFactors

    public final float[] getScaleFactors(float[] scaleFactors)

  Returns the scale factors in the given array. The array is also returned for convenience. If scaleFactors is null, a new array will be allocated.

### getOffsets

    public final float[] getOffsets(float[] offsets)

  Returns the offsets in the given array. The array is also returned for convenience. If offsets is null, a new array will be allocated.

### getNumFactors

    public final int getNumFactors()

  Returns the number of scaling factors and offsets used in this RescaleOp.

### filter

    public final BufferedImage filter(BufferedImage src,
                                      BufferedImage dst)

  Rescales the source BufferedImage. If the color model in the source image is not the same as that in the destination image, the pixels will be converted in the destination. If the destination image is null, a BufferedImage will be created with the source ColorModel. An IllegalArgumentException may be thrown if the number of scaling factors/offsets in this object does not meet the restrictions stated in the class comments above, or if the source image has an IndexColorModel.
  Specified by:
    `filter` in interface `BufferedImageOp`

### filter

    public final WritableRaster filter(Raster src,
                                       WritableRaster dst)

  Rescales the pixel data in the source Raster. If the destination Raster is null, a new Raster will be created. The source and destination must have the same number of bands. Otherwise, an IllegalArgumentException is thrown. Note that the number of scaling factors/offsets in this object must meet the restrictions stated in the class comments above. Otherwise, an IllegalArgumentException is thrown.
  Specified by:
    `filter` in interface `RasterOp`

### getBounds2D

    public final Rectangle2D getBounds2D(BufferedImage src)

  Returns the bounding box of the rescaled destination image. Since this is not a geometric operation, the bounding box does not change.
  Specified by:
    `getBounds2D` in interface `BufferedImageOp`

### getBounds2D

    public final Rectangle2D getBounds2D(Raster src)

  Returns the bounding box of the rescaled destination Raster. Since this is not a geometric operation, the bounding box does not change.
  Specified by:
    `getBounds2D` in interface `RasterOp`

### createCompatibleDestImage

    public BufferedImage createCompatibleDestImage(BufferedImage src,
                                                   ColorModel destCM)

  Creates a zeroed destination image with the correct size and number of bands.
  Specified by:
    `createCompatibleDestImage` in interface `BufferedImageOp`
  Parameters:
    `src` - Source image for the filter operation.
    `destCM` - ColorModel of the destination. If null, the ColorModel of the source will be used.

### createCompatibleDestRaster

    public WritableRaster createCompatibleDestRaster(Raster src)

  Creates a zeroed destination Raster with the correct size and number of bands, given this source.
  Specified by:
    `createCompatibleDestRaster` in interface `RasterOp`

### getPoint2D

    public final Point2D getPoint2D(Point2D srcPt,
                                    Point2D dstPt)

  Returns the location of the destination point given a point in the source. If dstPt is non-null, it will be used to hold the return value. Since this is not a geometric operation, the srcPt will equal the dstPt.
  Specified by:
    `getPoint2D` in interface `BufferedImageOp`

### getRenderingHints

    public final RenderingHints getRenderingHints()

  Returns the rendering hints for this op.
  Specified by:
    `getRenderingHints` in interface `BufferedImageOp`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.